"use strict";
import Luci from './luci.js';
import Antifurto from './antifurto.js';
import { scenariToggleListener } from "./toggles.js";

// JSON templeate for scenario
const scenarioTemplate = {
    "nome": "",
    "data": ""
};

class Scenari {
    static scenariContainer;
    static addNameHere;
    static initialized = false;
    static scenarioAttivoToggle = null;
    static index = 0;

    constructor() {
        Scenari.scenariContainer = document.getElementById('scenariContainer');
        Scenari.addNameHere = document.getElementById('p');
        Scenari.init();
        Scenari.antifurtoListener();
        Scenari.anyModalListener();
    }

    static init() {
        const scenariBtn = document.getElementById('mainButtonContainer').children[1];
        scenariBtn.addEventListener('click', () => {
            Scenari.toggleContainer(true);
            Luci.toggleContainer(false);
            Antifurto.toggleContainer(false);
            if (!Scenari.initialized)
                Scenari.fillTable();
            Scenari.initialized = true;
        }, false);

        const registerBtn = document.getElementById('scenari-registra');
        registerBtn.addEventListener('click', event => {
            event.preventDefault();
            // TODO choose how to register the scenario
        }, false);
    }

    static antifurtoListener() {
        // for the antitheft button, before opening a modal, change the text of it then open it
        const antifurtoBtn = document.getElementById('scenari-stato-antifurto');
        const okBtn = document.getElementById('attiva-antifurto-btn');
        const modalBody = document.querySelector('#antifurto-modal .modal-body');
        const modalLauncher = document.getElementById('lancia-antifurto-modal');

        antifurtoBtn.addEventListener('click', () => {
            const children = modalBody.children;
            // p, p
            /*
            <p>Stai per abilitare l'antifurto.</p>
            <p>Vuoi continuare?</p>
            */

            if (antifurtoBtn.innerText === 'ON') {
                // the antitheft is on
                children[0].innerText = "Stai per disabilitare l'antifurto.";
                okBtn.innerText = 'Disattiva';
            } else {
                // the antitheft is off
                children[0].innerText = "Stai per abilitare l'antifurto.";
                okBtn.innerText = 'Attiva';
                // TODO activate the antitheft in the server
            }
            // launch the modal
            modalLauncher.click();
        }, false);

        // TODO get antifurto status from server and set it correctly
        // antifurtoBtn.innerText = 'ON';
        // antifurtoBtn.classList.remove('btn-danger');
        // antifurtoBtn.classList.add('btn-success');

        // antifurtoBtn.addEventListener('click', () => {
        //     // when it's called, the modal is shown
        //     
        // }, false);
    }

    static antifurtoModal() {
        const antifurtoOkBtn = document.getElementById('attiva-antifurto-btn');
        const closeBtn = document.querySelector('#antifurto-modal .btn.btn-danger');
        const antifurtoBtn = document.getElementById('scenari-stato-antifurto');
        antifurtoOkBtn.addEventListener('click', () => {
            // close modal
            closeBtn.click();
            // switch the antitheft status button
            const isActivatingAntitheft = antifurtoBtn.innerText === 'OFF';
            Scenari.toggleAntifurto(isActivatingAntitheft);

            // TODO set the status of the antitheft in the server
            // eventualmente impostare antifurto nella classe Antifurto
            if (isActivatingAntitheft)
                Scenari.activateRandomScenario();
            else
                Scenari.deactivateActiveScenario();
        }, false);
    }

    static anyModalListener() {
        // Scenari.anteprimaModal();
        Scenari.attivaScenarioModal();
        Scenari.registraModal();
        Scenari.antifurtoModal();
    }

    static attivaScenarioModal() {
        const modalBtn = document.getElementById('attiva-scenari-btn');
        const closeBtn = document.querySelector('#attiva-scenari-modal .btn.btn-danger');
        const antifurtoBtn = document.getElementById('scenari-stato-antifurto');

        modalBtn.addEventListener('click', () => {
            // close the modal by clicking on the close button
            closeBtn.click();
            // I have to get to the toggle and activate it from the value of the select
            const toggle = document.querySelector(`#${Scenari.addNameHere.value} .toggle-button`);
            // has the user chosen to activate the scenario?
            const isActivatingNewScenario = toggle !== Scenari.scenarioAttivoToggle;

            if (isActivatingNewScenario) {
                Scenari.activateToggleByPreview(toggle);
                // TODO activate the new scenario in the server

                // set the antitheft status for the on-screen button
                antifurtoBtn.innerText = 'ON';
                antifurtoBtn.classList.remove('btn-danger');
                antifurtoBtn.classList.add('btn-success');
            } else {
                //here toggle and Scenari.scenarioAttivoToggle are the same
                toggle.classList.remove('active');
                Scenari.scenarioAttivoToggle = null;
                // TODO deactivate the scenario in the server

                // set the antitheft status for the on-screen button
                antifurtoBtn.innerText = 'OFF';
                antifurtoBtn.classList.remove('btn-success');
                antifurtoBtn.classList.add('btn-danger');
            }
        }, false);
    }

    static registraModal() {
        const scenariModal = document.getElementById('scenari-modal');

        const registraBtn = document.getElementById('scenari-registra');
        const okBtn = scenariModal.querySelector('.btn.btn-info');
        const modalBody = scenariModal.querySelector('.modal-body');
        const htmlForModalBody = `<p>Stai per attivare la registrazione dei comandi.</p>
        <p>Dal momento in cui premerai sul bottone azzurro, inizierai a registrare tutte le interazioni con le tue luci.</p>
        <p>Inoltre disabiliterai eventuali scenari attivi.</p>
        <p>Una volta che sarai soddisfatto del risultato, torna su questa pagina per terminare la registrazione.</p>
        <p>Inizare la registrazione?</p>`
        const modalLauncher = document.getElementById('registra-modal-launcer');

        // const okBtn = scenariModal.querySelector('.btn.btn-info');
        // const registraBtn = document.getElementById('scenari-registra');
        const closeScenariModalBtn = scenariModal.querySelector('.btn.btn-danger');
        const endRecordingModalLauncher = document.getElementById('termina-registrazione-launcher');

        const endRecordingForm = document.getElementById('termina-registrazione-form');
        // const modalBody = scenariModal.querySelector('.modal-body');
        // htmlForModalBody = ...
        const closeRecordingBtn = document.getElementById('termina-registrazione-modal').querySelector('.btn.btn-danger');
        const campoNome = document.getElementById('nome-nuovo-scenario');


        Scenari.registraBtnListener(registraBtn, okBtn, modalBody, htmlForModalBody, modalLauncher);
        Scenari.submitRecordModalListener(okBtn, registraBtn, closeScenariModalBtn, endRecordingModalLauncher);
        Scenari.endRecordingListener(endRecordingForm, modalBody, htmlForModalBody, closeRecordingBtn, campoNome);
    }

    static registraBtnListener(registraBtn, okBtn, modalBody, htmlForModalBody, modalLauncher) {
        registraBtn.addEventListener('click', () => {
            const isAboutToRecord = registraBtn.innerText === 'Registra';
            // change text of okBtn
            okBtn.innerText = isAboutToRecord ? 'Registra' : 'Termina';
            // change inner text of the modal

            if (isAboutToRecord) {
                modalBody.innerHTML = htmlForModalBody;
            } else {
                modalBody.innerHTML = `<p>Stai per terminare la registrazione dei comandi.</p>
                    <p>Terminare la registrazione?</p>`;
            }
            // launch the modal
            modalLauncher.click();
        }, false);
    }

    static submitRecordModalListener(okBtn, registraBtn, closeScenariModalBtn, endRecordingModalLauncher) {
        okBtn.addEventListener('click', () => {
            const isAboutToRecord = registraBtn.innerText === 'Registra';
            // change 'registra' to 'termina' and viceversa
            registraBtn.innerText = isAboutToRecord ? 'Termina' : 'Registra';
            // close modal
            closeScenariModalBtn.click();
            // get the current time
            // const timeBegin = new Date();
            // TODO send a note to the server to start/stop recording

            // if the user ended the recording, show another modal to ask for the name of the scenario
            if (!isAboutToRecord) {
                endRecordingModalLauncher.click();
            }
        }, false);
    }

    static endRecordingListener(endRecordingForm, modalBody, htmlForModalBody, closeRecordingBtn, campoNome) {
        endRecordingForm.addEventListener('submit', event => {
            event.preventDefault();
            // reset the other modal and button
            modalBody.innerHTML = htmlForModalBody;
            // close the modal
            closeRecordingBtn.click();

            const name = campoNome.value;
            const timeEnd = new Date();

            const scenario = Object.assign({}, scenarioTemplate);
            scenario.nome = name;
            scenario.data = timeEnd.toLocaleDateString();// assign at scenario.data the string YYYY/MM/DD from timeEnd
            Scenari.mostraNuovoScenario(scenario);

            // clear the field for the next use
            campoNome.value = '';
        }, false);
    }

    static toggleAntifurto(activating) {
        const antifurtoBtn = document.getElementById('scenari-stato-antifurto');
        if(activating) {
            antifurtoBtn.innerText = 'ON';
            antifurtoBtn.classList.remove('btn-danger');
            antifurtoBtn.classList.add('btn-success');
        } else {
            antifurtoBtn.innerText = 'OFF';
            antifurtoBtn.classList.remove('btn-success');
            antifurtoBtn.classList.add('btn-danger');
        }
    }



    static activateRandomScenario() {
        const table = document.getElementById('table-row-scenari');

        // enable a random scenario
        const randomScenario = table.children[Math.floor(Math.random() * table.children.length)];

        const toggle = randomScenario.querySelector('.toggle-button');
        Scenari.activateToggleByPreview(toggle);
        // TODO activate the scenario in the server
    }

    static deactivateActiveScenario() {
        Scenari.scenarioAttivoToggle.classList.remove('active');
        Scenari.scenarioAttivoToggle = null;
        // TODO deactivate the scenario in the server
    }

    static fillTable() {
        // TODO get all scenari from server
        //FIXME remove this test
        const natale = Object.assign({}, scenarioTemplate);
        natale.nome = 'Natale';
        natale.data = new Date(2018, 11, 25).toLocaleDateString();
        const festaRepublica = Object.assign({}, scenarioTemplate);
        festaRepublica.nome = 'Festa della Repubblica';
        festaRepublica.data = new Date(2018, 6, 2).toLocaleDateString();
        var scenari = [
            natale,
            festaRepublica
        ];
        // const scenario = Object.assign({}, scenarioTemplate);

        for (const scenario of scenari) {
            Scenari.mostraNuovoScenario(scenario)
        }
    }


    static mostraNuovoScenario(scenario) {
        const { row, name } = Scenari.createScenarioRow(scenario);

        const tableBody = document.getElementById('table-row-scenari');
        tableBody.appendChild(row);

        const anteprimaBtn = row.querySelector('.badge.rounded-pill');
        Scenari.anteprimaListener(anteprimaBtn, scenario, name);

        // add the name of the scenario as option in the select of the modal
        const optionName = document.createElement('option');
        optionName.value = name;
        optionName.innerText = scenario.nome;
        Scenari.addNameHere.appendChild(optionName);

        const toggle = row.querySelector('.toggle-button');
        scenariToggleListener(toggle, name);


        Scenari.index++;
    }

    static anteprimaListener(anteprimaBtn, scenario, name) {
        const anterprimaModal = document.getElementById('anteprima-modal');
        const modalBody = anterprimaModal.querySelector('.modal-body');
        const modalLauncher = document.getElementById('anteprima-modal-launcher');
        const okBtn = document.getElementById('anteprima-scenari-btn');
        const scenarioTable = document.getElementById('table-row-scenari');
        anteprimaBtn.addEventListener('click', () => {
            // TODO get the scenario from the server

            // TODO show the scenario in the modal
            modalBody.innerHTML = `<p>${scenario.nome}</p>
            <p>${scenario.data}</p>
            <span class='invisible'>${name}</span>`;//FIXME remove this test
            // if the scenario is already active, change the okBtn text
            // to find if it's active, find the relative toggle
            // and check if it's active
            // const scenarioRow = scenarioTable.querySelector(`#${name}`);
            const toggle = scenarioTable.querySelector(`#${name} .toggle-button`);
            okBtn.innerText = toggle.classList.contains('active') ? 'Disattiva' : 'Attiva';
            // launch the modal
            modalLauncher.click();
        }, false);

        const closeBtn = anterprimaModal.querySelector('.btn.btn-danger');
        okBtn.addEventListener('click', () => {
            // close the modal
            closeBtn.click();
            // get the scenario from the modal body
            const scenarioName = modalBody.querySelector('.invisible').innerText;
            // find the scenario's row on the page
            // const scenarioRow = scenarioTable.querySelector(`#${scenarioName}`);
            const toggle = scenarioTable.querySelector(`#${scenarioName} .toggle-button`);
            Scenari.activateToggleByPreview(toggle,okBtn.innerText === 'Attiva');
        }, false);
    }

    static createScenarioRow(scenario) {
        const row = document.createElement('tr');
        const name = 'scenario-' + Scenari.index;
        row.id = name
        row.innerHTML = `<th scope="row">${scenario.nome.trim()}</th>
                        <td>
                            <span>${scenario.data}</span>
                        </td>
                        <td>
                            <h5>
                                <span class="badge rounded-pill bg-secondary">anteprima</span>
                            </h5>
                        </td>
                        <td>
                            <div class="switch-container no-box-sizing">
                                <div class="toggle-button no-box-sizing">
                                    <div class="inner-circle no-box-sizing"></div>
                                </div>
                            </div>
                            <span id="launch-modal-${name}" data-bs-toggle="modal" data-bs-target="#attiva-scenari-modal"></span>
                        </td>`;
        return { row, name };
    }

    static activateToggleByPreview(toggle,activating) {
        Scenari.scenarioAttivoToggle?.classList.remove('active');
        activating ? toggle.classList.add('active') : toggle.classList.remove('active');
        Scenari.scenarioAttivoToggle = toggle;
        // also toggle the antitheft button
        Scenari.toggleAntifurto(activating)
    }

    // toggle the visibility of the scenari container
    static toggleContainer(visible) {
        if (visible) {
            Scenari.scenariContainer.classList.remove('invisible');
        } else {
            Scenari.scenariContainer.classList.add('invisible');
        }
    }



}

export default Scenari;